<?php


/* a semi real life example
based in part on 
///// mortgage_calculator.php /////
    Copyright (c) 2002 David Tufts <http://dave.imarc.net>
    All rights reserved.
    

*/


if (!extension_loaded('dbdo')) {
    dl('dbdo.' . PHP_SHLIB_SUFFIX);
}

 
// set up source test to use database test..
DBDO::config('test','provider','MySQL');
DBDO::config('test','cnc','DATABASE=test;USER=alan');
//DBDO::debugLevel(1);

$x = new DBDO("test","test");

$x->query("drop table if exists accounts");
//$x = new DBDO("test","test");
$x->query("create table accounts (
        id int(11) auto_increment primary key,
        description varchar(64) default '',
        at_date date,
        is_asset int(1) default 0,
        value numeric(12,2)
    )"
);


function get_interest_factor($year_term, $monthly_interest_rate) {
    global $base_rate;
    
    $factor      = 0;
    $base_rate   = 1 + $monthly_interest_rate;
    $denominator = $base_rate;
    for ($i=0; $i < ($year_term * 12); $i++) {
        $factor += (1 / $denominator);
        $denominator *= $base_rate;
    }
    return $factor;
}        

$sale_price                      = 2000000; // million dollar houses (yes houses cost that much in HK)
$monthly_rental                  = 6500;   // yes rents are expensive here :)
$year_term                       = 15;
$down_percent                    = 30;
$this_year_interest_paid         = 0;
$this_year_principal_paid        = 0;
$annual_interest_percent         = 2.5; // currently hong kong prime = 5%, banks offer prime - 2.5
$start_month = '2005-01-01';


$month_term              = $year_term * 12;
$down_payment            = $sale_price * ($down_percent / 100);
$annual_interest_rate    = $annual_interest_percent / 100;
$monthly_interest_rate   = $annual_interest_rate / 12;
$financing_price         = $sale_price - $down_payment;
$monthly_factor          = get_interest_factor($year_term, $monthly_interest_rate);
$monthly_payment         = $financing_price / $monthly_factor;
$start_month_ts          = strtotime($start_month);

$principal     = $financing_price;
$current_month = 1;
$current_year  = 1;
        // This basically, re-figures out the monthly payment, again.
$power = -($month_term);
$denom = pow((1 + $monthly_interest_rate), $power);
$monthly_payment = $principal * ($monthly_interest_rate / (1 - $denom));




$x = new DBDO("test","accounts");

$x->at_date = $start_month;
$x->description = 'Down Payment';
$x->value = -$down_payment;
$x->insert();

$x = $x->reproduce();
$x->at_date = $start_month;
$x->description = 'Net Asset Value Improved (Down Payment)';
$x->is_asset = 1;
$x->value = $down_payment;
$x->insert();
$real_value = $sale_price;

while ($current_month <= $month_term) {        
    $interest_paid     = $principal * $monthly_interest_rate;
    $principal_paid    = $monthly_payment - $interest_paid;
    $remaining_balance = $principal - $principal_paid;
    
    $principal = $remaining_balance;
    $actual_month_ts  = strtotime($start_month);
    $actual_month = date('Y-m-d',mktime(1,1,1,
            date('m',$start_month_ts)+$current_month,
            date('d',$start_month_ts),
            date('Y',$start_month_ts)));
    
    printf("Month %s Pay=%0.2f    Principal=%0.2f , Interest=%0.2f | Remain=%0.2f\n", 
                $actual_month,$monthly_payment, $principal_paid, $interest_paid, $remaining_balance);
    $x = new DBDO("test","accounts");
     
    
    $x->at_date = $actual_month;
    $x->description = 'Net Asset Value Improved (eg. principle paid)';
    $x->value = $principal_paid;
    $x->is_asset = 1;
    $x->insert();
    
    $x = $x->reproduce();
    
    $x->at_date = $actual_month;
    $x->description = 'Morgage Payment';
    $x->value = -$monthly_payment;
    $x->insert();
    if ($current_month > 3) {
        $x = $x->reproduce();
        $x->at_date = $actual_month;
        $x->description = 'Rental Paid';
        $x->value = $monthly_rental;
        $x->insert();    
    }
    
    if (($current_month % 12) == 0) {
        $old = $real_value;
        $real_value = 1.04 * $real_value;
        $appreciation = $real_value - $old;
        $x = $x->reproduce();
        $x->at_date = $actual_month;
        $x->description = 'Asset Appreciation';
        $x->is_asset = 1;
        $x->value = $appreciation;
        $x->insert();    
    }
         
     
    $current_month++;
    
    
}

/* now lets see what our bank acccount looks like :) */
$x = new DBDO("test","accounts");
$x->orderBy('at_date');
$x->query();
$x->balance = 1000000; // lets start with 1 million dollars (well I can dream :)
$x->asset_value = 0;
while ($x->fetch()) {
    if ($x->is_asset) {
        $x->asset_value += $x->value;
    } else {
        $x->balance += $x->value;
    }
    
    printf("Date %s Balance %0.2f   Asset %0.2f   NAV: %0.2f | %s ( %0.2f ) \n", 
                $x->at_date,$x->balance, $x->asset_value,($x->balance + $x->asset_value), $x->description, $x->value);
}
        


