--TEST--
03: Factory
--FILE--
<?php

require_once dirname(__FILE__).'/config.php';

// testing with creating self..
DBDO::config('test','class_name','DBDO');
//DBDO::debugLevel(DBDO::E_FULL);

echo "First test: using default object\n";
$x = DBDO::factory('test','test');

print_r($x);
print_r($x->info());


echo "Now with objects, and no autoload..\n";

class FactoryTest_test extends DBDO { } 

DBDO::config('test','class_name','factoryTest_%s');
$x = DBDO::factory('test','test');
print_r($x);
print_r($x->info());


echo "And finally with autoload\n";

DBDO::config('test','class_name','DBDO_%s');
DBDO::config('test','require_path',dirname(__FILE__).'/class%s.inc.php');
$x = DBDO::factory('test','test');
print_r($x);
print_r($x->info());


?>
--EXPECTF--
 
First test: using default object
DBDO Object
(
)
Array
(
    [table] => test
    [dsn] => test
    [database] => test
    [cnc] => DATABASE=test;USER=alan
    [provider] => MySQL
    [username] => alan
    [password] => 
    [row] => -1
    [rows] => 0
    [fetched] => Array
        (
        )

    [config] => Array
        (
            [require_path] => 
            [class_name] => DBDO
            [links] => 
            [quote_identifiers] => 0
            [lowercase_columns] => 0
        )

    [sequence_column] => 
    [sequence_is_native] => 
    [sequence_assigned] => 
    [sequence_name] => 
    [keys] => Array
        (
        )

    [where] => 
    [group_by] => 
    [order_by] => 
    [having] => 
    [limit_from] => 
    [limit_qty] => 
    [select] => 
)
Now with objects, and no autoload..
FactoryTest_test Object
(
)
Array
(
    [table] => test
    [dsn] => test
    [database] => test
    [cnc] => DATABASE=test;USER=alan
    [provider] => MySQL
    [username] => alan
    [password] => 
    [row] => -1
    [rows] => 0
    [fetched] => Array
        (
        )

    [config] => Array
        (
            [require_path] => 
            [class_name] => factoryTest_%s
            [links] => 
            [quote_identifiers] => 0
            [lowercase_columns] => 0
        )

    [sequence_column] => 
    [sequence_is_native] => 
    [sequence_assigned] => 
    [sequence_name] => 
    [keys] => Array
        (
        )

    [where] => 
    [group_by] => 
    [order_by] => 
    [having] => 
    [limit_from] => 
    [limit_qty] => 
    [select] => 
)
And finally with autoload
DBDO_test Object
(
)
Array
(
    [table] => test
    [dsn] => test
    [database] => test
    [cnc] => DATABASE=test;USER=alan
    [provider] => MySQL
    [username] => alan
    [password] => 
    [row] => -1
    [rows] => 0
    [fetched] => Array
        (
        )

    [config] => Array
        (
            [require_path] => %s/dbdo/tests/class%s.inc.php
            [class_name] => DBDO_%s
            [links] => 
            [quote_identifiers] => 0
            [lowercase_columns] => 0
        )

    [sequence_column] => 
    [sequence_is_native] => 
    [sequence_assigned] => 
    [sequence_name] => 
    [keys] => Array
        (
        )

    [where] => 
    [group_by] => 
    [order_by] => 
    [having] => 
    [limit_from] => 
    [limit_qty] => 
    [select] => 
)
